/**
*	main.cpp
*	Copyright (C) 2007 ChrisDay 
*	Copyright (C) 2004 BionicDonkey
*	Copyright (C) 2004 Nate
*	Copyright (C) 2004 JoeyBloggs
*
*	This file is part of DigitalWatch, a free DTV watching and recording
*	program for the VisionPlus DVB-T.
*
*	DigitalWatch is free software; you can redistribute it and/or modify
*	it under the terms of the GNU General Public License as published by
*	the Free Software Foundation; either version 2 of the License, or
*	(at your option) any later version.
*
*	DigitalWatch is distributed in the hope that it will be useful,
*	but WITHOUT ANY WARRANTY; without even the implied warranty of
*	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*	GNU General Public License for more details.
*
*	You should have received a copy of the GNU General Public License
*	along with DigitalWatch; if not, write to the Free Software
*	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#include "stdafx.h"
#include "ScanChannelsBDA.h"
#include "FilterGraphTools.h"
#include "LogMessage.h"
#include "LogMessageWriter.h"
#include "LogMessageConsoleOutput.h"
#include "GlobalFunctions.h"
#include <ctime>
#include <stdio.h>
#include <time.h>

LogMessage g_log;
LogMessageConsoleOutput consOut;
LogMessageWriter lmw;

HRESULT ShowMenu();
HRESULT GetChannelInfo(long &freq, long &band);
HRESULT GetFileName(LPTSTR pFilename);

int	_tmain(int argc, _TCHAR* argv[])
{
	HRESULT hr;


	//	time_t curr=time(0);

	time_t rawtime;
	time ( &rawtime );

	//	printf ( "The current local time is: %s", ctime (&rawtime) );


	//cout << "current time is: " << curr <<endl;

	//char logfilename = "ScanChannelsBDA_" && curr && ".log";


	lmw.SetFilename(L"ScanChannelsBDA.log");
	//lmw.SetFilename (logfilename);
	int writeHandle = g_log.AddCallback(&lmw);

	int consoleHandle = g_log.AddCallback(&consOut);

	(g_log << "\n").Write();
	(g_log << "\n").Write();


	//	g_log.ClearFile();
	(g_log << "-----------------------\n").Write();
	(g_log << "ScanChannelsBDA starting\n").Write();
	(g_log << ctime(&rawtime)).Write();
	(g_log << "\n").Write();
	g_log.LogVersionNumber();

	hr = ShowMenu();

	g_log.RemoveCallback(writeHandle);
	g_log.RemoveCallback(consoleHandle);

	return 0;
}

HRESULT ShowMenu()
{
	HRESULT hr = S_OK;

	BOOL bExit = FALSE ;
	char strMenuSelect[80];
	int iMenuSelect = 0;

	BDAChannelScan* cBDAChannelScan = new BDAChannelScan();
	cBDAChannelScan->AddRef();

	if (FAILED(hr = cBDAChannelScan->selectCard()))
	{
		return 1;
	}
	if (hr != S_OK)
		return 0;

	bExit = FALSE;
	while (bExit == FALSE)
	{
		cout << "\n" << endl;
		setrgb(0);
		cout << " ";
		setrgb(8);
		cout << "                                                                              " << endl;	

		setrgb(0);
		cout << " ";
		setrgb(21);
		cout << "                        DVB-T Scanner + SageTV output                         " << endl;	

		setrgb(0);
		cout << " ";
		setrgb(21);
		cout << "                                Version 2.6.3                                 " << endl;	

		setrgb(0);
		cout << " ";
		setrgb(8);
		cout << "                                                                              " << endl;	

		setrgb(0);
		cout << " ";
		setrgb(8);
		cout << " ";
		setrgb(20);
		cout << "                    ";
		setrgb(8);
		cout << " ";
		setrgb(20);
		cout << "                                                       ";
		setrgb(8);
		cout << " " << endl;


		setrgb(0);
		cout << " ";
		setrgb(8);
		cout << " ";
		setrgb(20);
		cout << "        Scan        ";
		setrgb(8);
		cout << " ";
		setrgb(20);
		cout << "                       Options                         ";
		setrgb(8);
		cout << " " << endl;

		/*
		setrgb(0);
		cout << " ";
		setrgb(8);
		cout << " ";
		setrgb(20);
		cout << "                    ";
		setrgb(8);
		cout << " ";
		setrgb(20);
		cout << "                         ";
		setrgb(8);
		cout << " ";
		setrgb(20);
		cout << "                         ";
		setrgb(8);
		cout << " " << endl;
		*/

		/*	setrgb(0);
		cout << " ";
		setrgb(8);
		cout << "                                                                              " << endl;
		*/

		setrgb(0);
		cout << " ";
		setrgb(8);
		cout << " ";
		setrgb(20);
		cout << "____________________";
		setrgb(8);
		cout << " ";
		setrgb(20);
		cout << "_______________________________________________________";
		setrgb(8);
		cout << " " << endl;


		setrgb(0);
		cout << " ";
		setrgb(8);
		cout << " ";
		setrgb(20);
		cout << "                    ";
		setrgb(8);
		cout << " ";
		setrgb(20);
		cout << "                                                       ";
		setrgb(8);
		cout << " " << endl;


		setrgb(0);
		cout << " ";
		setrgb(8);
		cout << " ";
		setrgb(20);
		cout << " All Frequencies:   ";
		setrgb(8);
		cout << " ";
		setrgb(20);
		cout << " General:                                              ";
		setrgb(8);
		cout << " " << endl;


		setrgb(0);
		cout << " ";
		setrgb(8);
		cout << " ";
		setrgb(20);
		cout << "  1. UK             ";
		setrgb(8);
		cout << " ";
		setrgb(20);
		cout << "  8. Verbose Output:";
		cout << " "<< (cBDAChannelScan->IsVerbose() ? "Off" : "On ") <<"                               ";
		setrgb(8);
		cout << " " << endl;



		setrgb(0);
		cout << " ";
		setrgb(8);
		cout << " ";
		setrgb(20);
		cout << "  2. Australia      ";
		setrgb(8);
		cout << " ";
		setrgb(20);
		cout << "  9. Lock Detection Mode: ";
		switch (cBDAChannelScan->LockDetectionMode())
		{
		case LOCK_MODE_LOCKED:
			cout << "(Signal Locked !=0)          "; break;
		case LOCK_MODE_QUALITY:
			cout << "(Quality > 0)                "; break;
		default:
			cout << "Unknown Mode                 "; break;
		};
		setrgb(8);
		cout << " " << endl;



		setrgb(0);
		cout << " ";
		setrgb(8);
		cout << " ";
		setrgb(20);
		cout << "  3. Europe         ";
		setrgb(8);
		cout << " ";
		setrgb(20);
		cout << "                                                       ";
		setrgb(8);
		cout << " " << endl;



		setrgb(0);
		cout << " ";
		setrgb(8);
		cout << " ";
		setrgb(20);
		cout << "  4. Taiwan         ";
		setrgb(8);
		cout << " ";
		setrgb(20);
		cout << " SageTV:                                               ";
		setrgb(8);
		cout << " " << endl;

		setrgb(0);
		cout << " ";
		setrgb(8);
		cout << " ";
		setrgb(20);
		cout << "                    ";
		setrgb(8);
		cout << " ";
		setrgb(20);
		cout << " 10. Output Channel list: ";
		cout << " "<< (cBDAChannelScan->SageTVOutputChannelList() ? "On " : "Off") <<"                         ";
		setrgb(8);
		cout << " " << endl;


		setrgb(0);
		cout << " ";
		setrgb(8);
		cout << " ";
		setrgb(20);
		cout << " Single Frequency:  ";
		setrgb(8);
		cout << " ";
		setrgb(20);
		cout << " 11. Use Exact Frequencies: ";
		cout << " "<< (cBDAChannelScan->SageTVUseExactFreq() ? "On " : "Off") <<"                       ";
		setrgb(8);
		cout << " " << endl;


		setrgb(0);
		cout << " ";
		setrgb(8);
		cout << " ";
		setrgb(20);
		cout << "  6. Averaged       ";
		setrgb(8);
		cout << " ";
		setrgb(20);
		cout << " 12. Include Radio Stations: ";
		cout << " "<< (cBDAChannelScan->SageTVIncludeRadio() ? "On " : "Off") <<"                      ";
		setrgb(8);
		cout << " " << endl;


		setrgb(0);
		cout << " ";
		setrgb(8);
		cout << " ";
		setrgb(20);
		cout << "  7. Scrolling      ";
		setrgb(8);
		cout << " ";
		setrgb(20);
		cout << " 13. Sorting: ";
		cout << " "<< (cBDAChannelScan->SageTVSortByLCN() ? (cBDAChannelScan->SageTVMoveDuplicates()?"LCN order (move duplicates) ":"LCN order                   ") : "Scan order                  ") <<"            ";
		setrgb(8);
		cout << " " << endl;

		setrgb(0);
		cout << " ";
		setrgb(8);
		cout << " ";
		setrgb(20);
		cout << "                    ";
		setrgb(8);
		cout << " ";
		setrgb(20);
		cout << "                                                       ";
		setrgb(8);
		cout << " " << endl;

		setrgb(0);
		cout << " ";
		setrgb(8);
		cout << " ";
		setrgb(20);
		cout << "                    ";
		setrgb(8);
		cout << " ";
		setrgb(20);
		cout << " 14. Exit                                              ";
		setrgb(8);
		cout << " " << endl;

		setrgb(0);
		cout << " ";
		setrgb(8);
		cout << " ";
		setrgb(20);
		cout << "                    ";
		setrgb(8);
		cout << " ";
		setrgb(20);
		cout << "                                                       ";
		setrgb(8);
		cout << " " << endl;

		setrgb(0);
		cout << " ";
		setrgb(8);
		cout << "                                                                              " << endl;


		/*	setrgb(0);
		cout << " ";
		setrgb(8);
		cout << " ";
		setrgb(0);
		cout << "________________________";
		setrgb(8);
		cout << " ";
		setrgb(0);
		cout << "_________________________";
		setrgb(8);
		cout << " ";
		setrgb(0);
		cout << "_________________________";
		setrgb(8);
		cout << " " << endl;
		*/

		setrgb(0);
		cout << "" << endl;


		cout << "Please select menu item by typing number [1 to 14]: ";


		cin >> strMenuSelect;

		iMenuSelect = 0;
		for (int i=0 ; (strMenuSelect[i]!='\0' && i<80) ; i++ )
		{
			if ((strMenuSelect[i] < '0') || (strMenuSelect[i] > '9'))
			{
				iMenuSelect = -1;
				break;
			}
			iMenuSelect *= 10;
			iMenuSelect += strMenuSelect[i] - '0';
		}

		switch (iMenuSelect)
		{
		case -1:
			cout << "Invalid number, Please Select again" << endl;  
			continue;

		case 1:
			long freq, band;
			cBDAChannelScan->scanAllUK166();  
			cBDAChannelScan->ShowChannelResults();
			break;    

		case 2:
			cBDAChannelScan->scanAllAus();
			cBDAChannelScan->ShowChannelResults();
			break;      

		case 3:
			cBDAChannelScan->scanAllEuro();
			cBDAChannelScan->ShowChannelResults();
			break;      

		case 4:
			cBDAChannelScan->scanAllTaiw();
			cBDAChannelScan->ShowChannelResults();
			break;      

		case 6:
			cout << "\n\nSingle Frequency Signal Statistics" << endl;
			GetChannelInfo(freq, band);
			cBDAChannelScan->SignalStatisticsAveraged(freq, band);
			break;

		case 7:
			cout << "\n\nSingle Frequency Signal Statistics" << endl;
			GetChannelInfo(freq, band);
			cBDAChannelScan->SignalStatisticsScrolling(freq, band);
			break;

		case 8:
			cBDAChannelScan->ToggleVerbose();
			break;

		case 9:
			cBDAChannelScan->ToggleLockDetectionMode();
			break;

		case 10:
			cBDAChannelScan->ToggleSageTVOutput();
			break;

		case 11:
			cBDAChannelScan->ToggleSageTVExactFreq();
			break;

		case 12:
			cBDAChannelScan->ToggleSageTVIncludeRadio();
			break;

		case 13:
			if(cBDAChannelScan->SageTVSortByLCN())
			{
				if(cBDAChannelScan->SageTVMoveDuplicates())
				{
					cBDAChannelScan->ToggleSageTVSorting();
				}
				cBDAChannelScan->ToggleSageTVMoveduplicates();
			}
			else
			{
				cBDAChannelScan->ToggleSageTVSorting();
			}
			break;

		case 14:
			bExit = TRUE;
			break;

		default:
			cout << "Error selecting, Please Select again" << endl;  
			continue;
		}
	}

	setrgb(0);
	cBDAChannelScan->StopGraph();

	return S_OK;
}

HRESULT GetChannelInfo(long &freq, long &band)
{
	freq = 0;
	band = 0;
	cout << "Enter Frequency (KHz):";
	cin >> freq;
	while (freq <= 0)
	{
		cout << "invalid number. Please try again:";
		cin >> freq;
	}

	cout << "Enter Bandwidth (MHz):";
	cin >> band;
	while (band <= 0)
	{
		cout << "invalid number. Please try again:";
		cin >> band;
	}
	cout << "\n";
	return S_OK;
}

HRESULT GetFileName(LPTSTR pFilename)
{
	pFilename[0] = '\0';

	// Setup the OPENFILENAME structure
	OPENFILENAME ofn = { sizeof(OPENFILENAME), NULL, NULL,
		TEXT("Timeshift Buffer Files\0*.tsbuffer\0All Files\0*.*\0\0"), NULL,
		0, 1,
		pFilename, MAX_PATH,
		NULL, 0,
		NULL,
		TEXT("Save As"),
		OFN_OVERWRITEPROMPT|OFN_HIDEREADONLY, 0, 0,
		TEXT(".tsbuffer"), 0, NULL, NULL };

	// Display the SaveFileName dialog.
	if( GetSaveFileName( &ofn ) == FALSE )
		return S_FALSE;

	return S_OK;
}
